% Elaborato di Robotica Industriale - prof G.A. Magnani
% M. Gritti e W. Spinelli
%
% Criterio per la scelta dei parametri del modello
%
% UNO STUDENTE
% m1     : maggiore tra giorno e mese di nascita
% m2     : minore tra giorno e mese di nascita
%
% DUE STUDENTI
% m1     : maggiore tra giorno di nascita del primo studente e mese di
%          nascita del secondo studente
% m2     : minore tra mese di nascita del primo studente e mese di nascita
%          del secondo studente
%
% N.B. Per semplificare il progetto del regolatore il valore della massa del
%      link 1 deve essere superiore al valore della massa del link 2

% DATI GEOMETRICI DEL ROBOT

m1 = 1;     % massa del link 1
m2 = 1;     % massa del link 2

g = 9.806;  % Accelerazione di gravit (sul pianeta Terra)
a = 1;      % Lunghezza dei link

% Momenti di inerzia visti al link1 e al link2
Jlink1 = (m1 + 7*m2)*a^2/3; % Inerzia massima (posizione di braccio esteso)
Jlink2 = (m2*a^2)/3;

% Posizioni iniziali dei giunti
q01 = 0;
q02 = 0;

% Coppie iniziali da applicare ai giunti
taull01 = 0.5*m1*g*a*cos(q01) + m2*g*a*(cos(q01) + 0.5*cos(q01+q02));
taull02 = 0.5*m2*g*a*cos(q01+q02);


% PARAMETRI DEI MOTORI E DELLA TASMISSIONE
% Dati per il dimesionameto
omega_max = 3;       % Velocit massima del carico
domega_max = 15;     % Accelerazione massima del carico

% Motore 1
Kt1   = 1;           % Costante di coppia
Jm1   = 1;           % Momento d'inerzia del motore
Dm1   = 0.0034;      % Coefficiente di attrito viscoso
% Riduttore 1  
n1    = 1;           % Rapporto di trasmissione
Kel1  = 1;           % Coefficiente di elasticit
Del1  = 0.0022;      % Coefficiente di smorzamento
Jrid1 = 1;           % Momento d'inerzia del riduttore

% Motore 2
Kt2   = 1;
Jm2   = 1;
Dm2   = 0.0034;
% Riduttore 2
n2    = 1;
Kel2  = 1;
Del2  = 0.0022;
Jrid2 = 1;

% Inizializzazioni delle posizioni dei motori
taulm01 = taull01/n1;
taulm02 = taull02/n2;
qm01 = n1*q01 + taulm01/Kel1;
qm02 = n2*q02 + taulm02/Kel2;


% VINCOLI PER LA VERIFICA DEL CORRETTO DIMENSIONAMENTO
tauc1 = 1;         % Coppia nominale del motore
N1    = 1;         % Velocit di rotazione nominale del motore
tauc2 = 1;
N2    = 1;

disp('Velocit massima')
disp([num2str(N1/n1*2*pi/60) '  >=  ' num2str(omega_max)])
disp([num2str(N2/n2*2*pi/60) '  >=  ' num2str(omega_max)])
disp(' ')
disp('Rapporto di inerzia:     1 <= rho <=5')
disp(['rho1    =    ' num2str(Jlink1/(n1^2*(Jm1+Jrid1)))])
disp(['rho2    =    ' num2str(Jlink2/(n2^2*(Jm2+Jrid2)))])
disp(' ')
disp('Coppia motrice massima')
disp([num2str(n1*tauc1) '  >=  ' ...
      num2str(Jlink1*domega_max + (0.5*m1+1.5*m2)*a^2*g + n1^2*(Jm1+Jrid1)*domega_max)])
disp([num2str(n2*tauc2) '  >=  ' ...
      num2str(Jlink2*domega_max + (0.5*m2)*a^2*g + n2^2*(Jm2+Jrid2)*domega_max)])

% Pesi dell'azione proporzionale e derivativa
b1 = 1;
c1 = 1;
b2 = 1;  
c2 = 1;

% Inizializzazione dei controllori
u01 = taulm01/Kt1;
u02 = taulm02/Kt2;


